Index: uspace/app/fontedit/fontedit.c
===================================================================
--- uspace/app/fontedit/fontedit.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/fontedit/fontedit.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -167,4 +167,38 @@
 }
 
+/** Adjust font underline Y0.
+ *
+ * @param fedit Font editor
+ */
+static void font_edit_adjust_underline_y0(font_edit_t *fedit,
+    gfx_coord_t change)
+{
+	gfx_font_metrics_t fmetrics;
+
+	gfx_font_get_metrics(fedit->font, &fmetrics);
+	fmetrics.underline_y0 += change;
+	(void) gfx_font_set_metrics(fedit->font, &fmetrics);
+
+	printf("New underline Y0: %d\n", fmetrics.underline_y0);
+	font_edit_paint(fedit);
+}
+
+/** Adjust font underline Y1.
+ *
+ * @param fedit Font editor
+ */
+static void font_edit_adjust_underline_y1(font_edit_t *fedit,
+    gfx_coord_t change)
+{
+	gfx_font_metrics_t fmetrics;
+
+	gfx_font_get_metrics(fedit->font, &fmetrics);
+	fmetrics.underline_y1 += change;
+	(void) gfx_font_set_metrics(fedit->font, &fmetrics);
+
+	printf("New underline Y1: %d\n", fmetrics.underline_y1);
+	font_edit_paint(fedit);
+}
+
 /** Handle font editor close event.
  *
@@ -314,4 +348,16 @@
 		font_edit_adjust_leading(fedit, +1);
 		break;
+	case KC_U:
+		font_edit_adjust_underline_y0(fedit, -1);
+		break;
+	case KC_I:
+		font_edit_adjust_underline_y0(fedit, +1);
+		break;
+	case KC_O:
+		font_edit_adjust_underline_y1(fedit, -1);
+		break;
+	case KC_P:
+		font_edit_adjust_underline_y1(fedit, +1);
+		break;
 	case KC_X:
 		(void) gfx_glyph_bmp_clear(fedit->gbmp);
@@ -457,4 +503,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = fedit->font;
 	fmt.color = color;
 
@@ -462,5 +509,5 @@
 	pos.y = y;
 
-	return gfx_puttext(fedit->font, &pos, &fmt, str);
+	return gfx_puttext(&pos, &fmt, str);
 }
 
@@ -521,4 +568,5 @@
 	gfx_color_t *color = NULL;
 	gfx_rect_t rect;
+	gfx_rect_t rect2;
 	gfx_rect_t grect;
 	gfx_font_metrics_t fmetrics;
@@ -564,4 +612,24 @@
 	    fmetrics.leading, &rect);
 	rect.p1.x += 100;
+
+	rc = gfx_fill_rect(fedit->gc, &rect);
+	if (rc != EOK)
+		goto error;
+
+	gfx_color_delete(color);
+
+	/* Display underline */
+
+	rc = gfx_color_new_rgb_i16(0x4000, 0x4000, 0, &color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_set_color(fedit->gc, color);
+	if (rc != EOK)
+		goto error;
+
+	font_edit_gpix_to_disp(fedit, 0, fmetrics.underline_y0, &rect);
+	font_edit_gpix_to_disp(fedit, 10, fmetrics.underline_y1, &rect2);
+	rect.p1 = rect2.p0;
 
 	rc = gfx_fill_rect(fedit->gc, &rect);
@@ -719,5 +787,5 @@
 	 * to rect
 	 */
-	ui_wdecor_rect_from_app(params.style, &rect, &wrect);
+	ui_wdecor_rect_from_app(ui, params.style, &rect, &wrect);
 	off = wrect.p0;
 	gfx_rect_rtranslate(&off, &wrect, &params.rect);
Index: uspace/app/gfxdemo/gfxdemo.c
===================================================================
--- uspace/app/gfxdemo/gfxdemo.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/gfxdemo/gfxdemo.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -51,4 +51,5 @@
 #include <ui/window.h>
 #include <ui/wdecor.h>
+#include "gfxdemo.h"
 
 static void wnd_close_event(void *);
@@ -68,8 +69,14 @@
 };
 
+static void demo_kbd_event(kbd_event_t *);
+
 static bool quit = false;
+static FIBRIL_MUTEX_INITIALIZE(quit_lock);
+static FIBRIL_CONDVAR_INITIALIZE(quit_cv);
 static gfx_typeface_t *tface;
 static gfx_font_t *font;
 static gfx_coord_t vpad;
+static console_ctrl_t *con = NULL;
+static ui_t *ui;
 
 /** Determine if we are running in text mode.
@@ -83,4 +90,40 @@
 	// XXX Need a proper way to determine text mode
 	return w <= 80;
+}
+
+/** Sleep until timeout or quit request.
+ *
+ * @param msec Number of microseconds to sleep for
+ */
+static void demo_msleep(unsigned msec)
+{
+	errno_t rc;
+	usec_t usec;
+	cons_event_t cevent;
+
+	if (ui != NULL)
+		ui_unlock(ui);
+	fibril_mutex_lock(&quit_lock);
+	if (!quit) {
+		if (con != NULL) {
+			usec = (usec_t)msec * 1000;
+			while (usec > 0 && !quit) {
+				rc = console_get_event_timeout(con, &cevent, &usec);
+				if (rc == EOK) {
+					if (cevent.type == CEV_KEY) {
+						fibril_mutex_unlock(&quit_lock);
+						demo_kbd_event(&cevent.ev.key);
+						fibril_mutex_lock(&quit_lock);
+					}
+				}
+			}
+		} else {
+			(void) fibril_condvar_wait_timeout(&quit_cv, &quit_lock,
+			    (usec_t)msec * 1000);
+		}
+	}
+	fibril_mutex_unlock(&quit_lock);
+	if (ui != NULL)
+		ui_lock(ui);
 }
 
@@ -238,4 +281,5 @@
 
 		gfx_text_fmt_init(&fmt);
+		fmt.font = font;
 		fmt.color = color;
 		fmt.halign = gfx_halign_center;
@@ -243,6 +287,6 @@
 
 		pos.x = w / 2;
-		pos.y = h - 1;
-		rc = gfx_puttext(font, &pos, &fmt, text);
+		pos.y = h;
+		rc = gfx_puttext(&pos, &fmt, text);
 		if (rc != EOK) {
 			printf("Error rendering text.\n");
@@ -315,6 +359,5 @@
 		gfx_color_delete(color);
 
-		fibril_usleep(500 * 1000);
-
+		demo_msleep(500);
 		if (quit)
 			break;
@@ -350,5 +393,5 @@
 		for (j = 0; j < h; j++) {
 			pixelmap_put_pixel(&pixelmap, i, j,
-			    PIXEL(0, (i % 30) < 3 ? 255 : 0,
+			    PIXEL(255, (i % 30) < 3 ? 255 : 0,
 			    (j % 30) < 3 ? 255 : 0, i / 2));
 		}
@@ -386,5 +429,5 @@
 			k = i * i + j * j;
 			pixelmap_put_pixel(&pixelmap, i, j,
-			    PIXEL(0, k, k, k));
+			    PIXEL(255, k, k, k));
 		}
 	}
@@ -421,6 +464,6 @@
 			k = i * i + j * j;
 			pixelmap_put_pixel(&pixelmap, i, j,
-			    k < w * w / 2 ? PIXEL(0, 0, 255, 0) :
-			    PIXEL(0, 255, 0, 255));
+			    k < w * w / 2 ? PIXEL(255, 0, 255, 0) :
+			    PIXEL(255, 255, 0, 255));
 		}
 	}
@@ -477,6 +520,6 @@
 			if (rc != EOK)
 				goto error;
-			fibril_usleep(250 * 1000);
-
+
+			demo_msleep(250);
 			if (quit)
 				goto out;
@@ -538,6 +581,5 @@
 		}
 
-		fibril_usleep(500 * 1000);
-
+		demo_msleep(500);
 		if (quit)
 			break;
@@ -579,5 +621,5 @@
 	params.rect.p1.y = 40;
 	params.flags = bmpf_color_key;
-	params.key_color = PIXEL(0, 255, 0, 255);
+	params.key_color = PIXEL(255, 255, 0, 255);
 
 	rc = gfx_bitmap_create(gc, &params, NULL, &bitmap);
@@ -599,6 +641,5 @@
 		}
 
-		fibril_usleep(500 * 1000);
-
+		demo_msleep(500);
 		if (quit)
 			break;
@@ -689,9 +730,10 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 	fmt.color = color;
 
 	pos.x = rect.p0.x;
 	pos.y = rect.p0.y;
-	rc = gfx_puttext(font, &pos, &fmt, "Top left");
+	rc = gfx_puttext(&pos, &fmt, "Top left");
 	if (rc != EOK) {
 		printf("Error rendering text.\n");
@@ -702,5 +744,5 @@
 	pos.y = rect.p0.y;
 	fmt.halign = gfx_halign_center;
-	rc = gfx_puttext(font, &pos, &fmt, "Top center");
+	rc = gfx_puttext(&pos, &fmt, "Top center");
 	if (rc != EOK)
 		goto error;
@@ -709,5 +751,5 @@
 	pos.y = rect.p0.y;
 	fmt.halign = gfx_halign_right;
-	rc = gfx_puttext(font, &pos, &fmt, "Top right");
+	rc = gfx_puttext(&pos, &fmt, "Top right");
 	if (rc != EOK)
 		goto error;
@@ -718,5 +760,5 @@
 	pos.y = (rect.p0.y + rect.p1.y - 1) / 2;
 	fmt.halign = gfx_halign_left;
-	rc = gfx_puttext(font, &pos, &fmt, "Center left");
+	rc = gfx_puttext(&pos, &fmt, "Center left");
 	if (rc != EOK)
 		goto error;
@@ -725,5 +767,5 @@
 	pos.y = (rect.p0.y + rect.p1.y - 1) / 2;
 	fmt.halign = gfx_halign_center;
-	rc = gfx_puttext(font, &pos, &fmt, "Center");
+	rc = gfx_puttext(&pos, &fmt, "Center");
 	if (rc != EOK)
 		goto error;
@@ -732,5 +774,5 @@
 	pos.y = (rect.p0.y + rect.p1.y - 1) / 2;
 	fmt.halign = gfx_halign_right;
-	rc = gfx_puttext(font, &pos, &fmt, "Center right");
+	rc = gfx_puttext(&pos, &fmt, "Center right");
 	if (rc != EOK)
 		goto error;
@@ -741,5 +783,5 @@
 	pos.y = rect.p1.y - 1;
 	fmt.halign = gfx_halign_left;
-	rc = gfx_puttext(font, &pos, &fmt, "Bottom left");
+	rc = gfx_puttext(&pos, &fmt, "Bottom left");
 	if (rc != EOK)
 		goto error;
@@ -748,5 +790,5 @@
 	pos.y = rect.p1.y;
 	fmt.halign = gfx_halign_center;
-	rc = gfx_puttext(font, &pos, &fmt, "Bottom center");
+	rc = gfx_puttext(&pos, &fmt, "Bottom center");
 	if (rc != EOK)
 		goto error;
@@ -755,5 +797,5 @@
 	pos.y = rect.p1.y;
 	fmt.halign = gfx_halign_right;
-	rc = gfx_puttext(font, &pos, &fmt, "Bottom right");
+	rc = gfx_puttext(&pos, &fmt, "Bottom right");
 	if (rc != EOK)
 		goto error;
@@ -762,4 +804,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 
 	for (i = 0; i < 8; i++) {
@@ -776,8 +819,9 @@
 
 		fmt.color = color;
+		fmt.underline = !fmt.underline;
 
 		pos.x = w / 20;
 		pos.y = (6 + i) * h / 15;
-		rc = gfx_puttext(font, &pos, &fmt, "The quick brown fox jumps over the lazy dog.");
+		rc = gfx_puttext(&pos, &fmt, "The quick brown fox jumps over the lazy dog.");
 		if (rc != EOK)
 			goto error;
@@ -787,5 +831,86 @@
 
 	for (i = 0; i < 10; i++) {
-		fibril_usleep(500 * 1000);
+		demo_msleep(500);
+		if (quit)
+			break;
+	}
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Run text abbreviation demo on a graphic context.
+ *
+ * @param gc Graphic context
+ * @param w Width
+ * @param h Height
+ */
+static errno_t demo_text_abbr(gfx_context_t *gc, gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_color_t *color = NULL;
+	gfx_rect_t rect;
+	gfx_coord2_t pos;
+	gfx_text_fmt_t fmt;
+	int i;
+	errno_t rc;
+
+	if (quit)
+		return EOK;
+
+	rc = demo_begin(gc, w, h, "Text abbreviation");
+	if (rc != EOK)
+		goto error;
+
+	for (i = 0; i < 11; i++) {
+
+		rc = gfx_color_new_rgb_i16(0, 0, 0x8000, &color);
+		if (rc != EOK)
+			goto error;
+
+		rc = gfx_set_color(gc, color);
+		if (rc != EOK)
+			goto error;
+
+		rect.p0.x = w / 20;
+		rect.p0.y = (2 + 2 * i) * h / 25;
+		rect.p1.x = w - w / 20 - w * i / 12;
+		rect.p1.y = (3 + 2 * i) * h / 25;
+
+		rc = gfx_fill_rect(gc, &rect);
+		if (rc != EOK)
+			goto error;
+
+		gfx_color_delete(color);
+
+		if (demo_is_text(w, h)) {
+			rc = gfx_color_new_ega(0x1f, &color);
+			if (rc != EOK)
+				goto error;
+		} else {
+			rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff,
+			    &color);
+			if (rc != EOK)
+				goto error;
+		}
+
+		gfx_text_fmt_init(&fmt);
+		fmt.font = font;
+		fmt.color = color;
+		fmt.abbreviate = true;
+		fmt.width = rect.p1.x - rect.p0.x;
+
+		pos.x = rect.p0.x;
+		pos.y = rect.p0.y;
+		rc = gfx_puttext(&pos, &fmt,
+		    "The quick brow fox jumps over the lazy dog!");
+		if (rc != EOK) {
+			printf("Error rendering text.\n");
+			goto error;
+		}
+	}
+
+	for (i = 0; i < 10; i++) {
+		demo_msleep(500);
 		if (quit)
 			break;
@@ -884,6 +1009,5 @@
 		}
 
-		fibril_usleep(500 * 1000);
-
+		demo_msleep(500);
 		if (quit)
 			break;
@@ -932,4 +1056,8 @@
 			goto error;
 
+		rc = demo_text_abbr(gc, w, h);
+		if (rc != EOK)
+			goto error;
+
 		rc = demo_clip(gc, w, h);
 		if (rc != EOK)
@@ -947,15 +1075,17 @@
 static errno_t demo_console(void)
 {
-	console_ctrl_t *con = NULL;
 	console_gc_t *cgc = NULL;
 	gfx_context_t *gc;
-	errno_t rc;
-
-	printf("Init console..\n");
+	sysarg_t cols, rows;
+	errno_t rc;
+
 	con = console_init(stdin, stdout);
 	if (con == NULL)
 		return EIO;
 
-	printf("Create console GC\n");
+	rc = console_get_size(con, &cols, &rows);
+	if (rc != EOK)
+		return rc;
+
 	rc = console_gc_create(con, stdout, &cgc);
 	if (rc != EOK)
@@ -964,5 +1094,5 @@
 	gc = console_gc_get_ctx(cgc);
 
-	rc = demo_loop(gc, 80, 25);
+	rc = demo_loop(gc, cols, rows);
 	if (rc != EOK)
 		return rc;
@@ -973,4 +1103,16 @@
 
 	return EOK;
+}
+
+static errno_t demo_ui_fibril(void *arg)
+{
+	demo_ui_args_t *args = (demo_ui_args_t *)arg;
+	errno_t rc;
+
+	ui_lock(args->ui);
+	rc = demo_loop(args->gc, args->dims.x, args->dims.y);
+	ui_unlock(args->ui);
+	ui_quit(args->ui);
+	return rc;
 }
 
@@ -978,5 +1120,4 @@
 static errno_t demo_ui(const char *display_spec)
 {
-	ui_t *ui = NULL;
 	ui_wnd_params_t params;
 	ui_window_t *window = NULL;
@@ -985,11 +1126,19 @@
 	gfx_rect_t wrect;
 	gfx_coord2_t off;
-	errno_t rc;
-
-	printf("Init UI..\n");
+	gfx_rect_t ui_rect;
+	gfx_coord2_t dims;
+	demo_ui_args_t args;
+	fid_t fid;
+	errno_t rc;
 
 	rc = ui_create(display_spec, &ui);
 	if (rc != EOK) {
 		printf("Error initializing UI (%s)\n", display_spec);
+		goto error;
+	}
+
+	rc = ui_get_rect(ui, &ui_rect);
+	if (rc != EOK) {
+		printf("Error getting display size.\n");
 		goto error;
 	}
@@ -1003,11 +1152,23 @@
 	params.caption = "GFX Demo";
 
+	/* Do not decorate the window in fullscreen mode */
+	if (ui_is_fullscreen(ui))
+		params.style &= ~ui_wds_decorated;
+
 	/*
 	 * Compute window rectangle such that application area corresponds
 	 * to rect
 	 */
-	ui_wdecor_rect_from_app(params.style, &rect, &wrect);
+	ui_wdecor_rect_from_app(ui, params.style, &rect, &wrect);
 	off = wrect.p0;
 	gfx_rect_rtranslate(&off, &wrect, &params.rect);
+
+	gfx_rect_dims(&ui_rect, &dims);
+
+	/* Make sure window is not larger than the entire screen */
+	if (params.rect.p1.x > dims.x)
+		params.rect.p1.x = dims.x;
+	if (params.rect.p1.y > dims.y)
+		params.rect.p1.y = dims.y;
 
 	rc = ui_window_create(ui, &params, &window);
@@ -1025,10 +1186,23 @@
 	}
 
-	task_retval(0);
-
-	rc = demo_loop(gc, rect.p1.x, rect.p1.y);
-	if (rc != EOK)
-		goto error;
-
+	ui_window_get_app_rect(window, &rect);
+	gfx_rect_dims(&rect, &dims);
+
+	if (!ui_is_fullscreen(ui))
+		task_retval(0);
+
+	args.gc = gc;
+	args.dims = dims;
+	args.ui = ui;
+
+	fid = fibril_create(demo_ui_fibril, (void *)&args);
+	if (fid == 0) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	fibril_add_ready(fid);
+
+	ui_run(ui);
 	ui_window_destroy(window);
 	ui_destroy(ui);
@@ -1052,6 +1226,4 @@
 	errno_t rc;
 
-	printf("Init display..\n");
-
 	rc = display_open(display_svc, &display);
 	if (rc != EOK) {
@@ -1065,4 +1237,5 @@
 	params.rect.p1.x = 400;
 	params.rect.p1.y = 300;
+	params.caption = "GFX Demo";
 
 	rc = display_window_create(display, &params, &wnd_cb, NULL, &window);
@@ -1094,28 +1267,54 @@
 }
 
+static void demo_quit(void)
+{
+	fibril_mutex_lock(&quit_lock);
+	quit = true;
+	fibril_mutex_unlock(&quit_lock);
+	fibril_condvar_broadcast(&quit_cv);
+}
+
 static void wnd_close_event(void *arg)
 {
-	printf("Close event\n");
-	quit = true;
+	demo_quit();
+}
+
+static void demo_kbd_event(kbd_event_t *event)
+{
+	if (event->type == KEY_PRESS) {
+		/* Ctrl-Q */
+		if ((event->mods & KM_CTRL) != 0 &&
+		    (event->mods & KM_ALT) == 0 &&
+		    (event->mods & KM_SHIFT) == 0 &&
+		    event->key == KC_Q) {
+			demo_quit();
+		}
+
+		/* Escape */
+		if ((event->mods & KM_CTRL) == 0 &&
+		    (event->mods & KM_ALT) == 0 &&
+		    (event->mods & KM_SHIFT) == 0 &&
+		    event->key == KC_ESCAPE) {
+			demo_quit();
+		}
+	}
 }
 
 static void wnd_kbd_event(void *arg, kbd_event_t *event)
 {
-	printf("Keyboard event type=%d key=%d\n", event->type, event->key);
-	if (event->type == KEY_PRESS)
-		quit = true;
+	(void)arg;
+	demo_kbd_event(event);
 }
 
 static void uiwnd_close_event(ui_window_t *window, void *arg)
 {
-	printf("Close event\n");
-	quit = true;
+	demo_quit();
 }
 
 static void uiwnd_kbd_event(ui_window_t *window, void *arg, kbd_event_t *event)
 {
-	printf("Keyboard event type=%d key=%d\n", event->type, event->key);
-	if (event->type == KEY_PRESS)
-		quit = true;
+	(void)window;
+	(void)arg;
+	demo_kbd_event(event);
 }
 
@@ -1129,4 +1328,5 @@
 	errno_t rc;
 	const char *display_svc = DISPLAY_DEFAULT;
+	const char *ui_display_spec = UI_ANY_DEFAULT;
 	int i;
 
@@ -1141,5 +1341,5 @@
 			}
 
-			display_svc = argv[i++];
+			display_svc = ui_display_spec = argv[i++];
 		} else {
 			printf("Invalid option '%s'.\n", argv[i]);
@@ -1158,5 +1358,5 @@
 			return 1;
 	} else if (str_cmp(argv[i], "ui") == 0) {
-		rc = demo_ui(display_svc);
+		rc = demo_ui(ui_display_spec);
 		if (rc != EOK)
 			return 1;
Index: uspace/app/gfxdemo/gfxdemo.h
===================================================================
--- uspace/app/gfxdemo/gfxdemo.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/gfxdemo/gfxdemo.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gfxdemo
+ * @{
+ */
+/**
+ * @file Graphic demo
+ */
+
+#ifndef GFXDEMO_H
+#define GFXDEMO_H
+
+#include <gfx/context.h>
+#include <gfx/coord.h>
+#include <ui/ui.h>
+
+typedef struct {
+	gfx_context_t *gc;
+	gfx_coord2_t dims;
+	ui_t *ui;
+} demo_ui_args_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/hbench/benchlist.c
===================================================================
--- uspace/app/hbench/benchlist.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/hbench/benchlist.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2018 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2018 Vojtech Horky
  * All rights reserved.
@@ -42,8 +42,13 @@
 	&benchmark_fibril_mutex,
 	&benchmark_file_read,
+	&benchmark_rand_read,
+	&benchmark_seq_read,
 	&benchmark_malloc1,
 	&benchmark_malloc2,
 	&benchmark_ns_ping,
-	&benchmark_ping_pong
+	&benchmark_ping_pong,
+	&benchmark_read1k,
+	&benchmark_taskgetid,
+	&benchmark_write1k,
 };
 
Index: uspace/app/hbench/disk/randread.c
===================================================================
--- uspace/app/hbench/disk/randread.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/hbench/disk/randread.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,146 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup hbench
+ * @{
+ */
+
+#include <block.h>
+#include <loc.h>
+#include <str_error.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "../hbench.h"
+
+/** Execute disk random read benchmark. */
+static bool runner(bench_env_t *env, bench_run_t *run, uint64_t size)
+{
+	const char *disk;
+	const char *nbstr;
+	service_id_t svcid;
+	size_t block_size;
+	aoff64_t dev_nblocks;
+	aoff64_t baddr;
+	bool block_inited = false;
+	char *buf = NULL;
+	uint64_t i;
+	errno_t rc;
+	int nitem;
+	unsigned nb;
+
+	disk = bench_env_param_get(env, "disk", NULL);
+	if (disk == NULL) {
+		bench_run_fail(run, "You must specify 'disk' parameter.");
+		goto error;
+	}
+
+	nbstr = bench_env_param_get(env, "nb", "1");
+	nitem = sscanf(nbstr, "%u", &nb);
+	if (nitem < 1) {
+		bench_run_fail(run, "'nb' must be an integer number of blocks.");
+		goto error;
+	}
+
+	rc = loc_service_get_id(disk, &svcid, 0);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed resolving device '%s'", disk);
+		goto error;
+	}
+
+	rc = block_init(svcid);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed opening block device '%s'",
+		    disk);
+	}
+
+	block_inited = true;
+
+	rc = block_get_bsize(svcid, &block_size);
+	if (rc != EOK) {
+		bench_run_fail(run, "error determining device block size.");
+		goto error;
+	}
+
+	rc = block_get_nblocks(svcid, &dev_nblocks);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed to obtain block device size.\n");
+		goto error;
+	}
+
+	if (dev_nblocks < nb) {
+		bench_run_fail(run, "device is smaller than %u blocks.\n",
+		    nb);
+		goto error;
+	}
+
+	buf = malloc(block_size * nb);
+	if (buf == NULL) {
+		bench_run_fail(run, "failed to allocate buffer (%zu bytes)",
+		    block_size * nb);
+		goto error;
+	}
+
+	bench_run_start(run);
+	for (i = 0; i < size; i++) {
+		/* Generate pseudo-random block address */
+		baddr = (rand() + rand() * RAND_MAX) % (dev_nblocks - nb + 1);
+
+		rc = block_read_direct(svcid, baddr, nb, buf);
+		if (rc != EOK) {
+			bench_run_fail(run, "failed to read blockd %llu-%llu: "
+			    "%s", (unsigned long long)baddr,
+			    (unsigned long long)(baddr + nb - 1),
+			    str_error(errno));
+			goto error;
+		}
+	}
+
+	bench_run_stop(run);
+	block_fini(svcid);
+	free(buf);
+
+	return true;
+error:
+	if (buf != NULL)
+		free(buf);
+	if (block_inited)
+		block_fini(svcid);
+	return false;
+}
+
+benchmark_t benchmark_rand_read = {
+	.name = "rand_read",
+	.desc = "Random disk read (must set 'disk' parameter).",
+	.entry = &runner,
+	.setup = NULL,
+	.teardown = NULL
+};
+
+/**
+ * @}
+ */
Index: uspace/app/hbench/disk/seqread.c
===================================================================
--- uspace/app/hbench/disk/seqread.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/hbench/disk/seqread.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,145 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup hbench
+ * @{
+ */
+
+#include <block.h>
+#include <loc.h>
+#include <str_error.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "../hbench.h"
+
+/** Execute disk sequential read benchmark. */
+static bool runner(bench_env_t *env, bench_run_t *run, uint64_t size)
+{
+	const char *disk;
+	const char *nbstr;
+	service_id_t svcid;
+	size_t block_size;
+	aoff64_t dev_nblocks;
+	aoff64_t baddr;
+	bool block_inited = false;
+	char *buf = NULL;
+	uint64_t i;
+	errno_t rc;
+	int nitem;
+	unsigned nb;
+
+	disk = bench_env_param_get(env, "disk", NULL);
+	if (disk == NULL) {
+		bench_run_fail(run, "Yo must specify 'disk' parameter.");
+		goto error;
+	}
+
+	nbstr = bench_env_param_get(env, "nb", "1");
+	nitem = sscanf(nbstr, "%u", &nb);
+	if (nitem < 1) {
+		bench_run_fail(run, "'nb' must be an integer number of blocks.");
+		goto error;
+	}
+
+	rc = loc_service_get_id(disk, &svcid, 0);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed resolving device '%s'", disk);
+		goto error;
+	}
+
+	rc = block_init(svcid);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed opening block device '%s'",
+		    disk);
+	}
+
+	block_inited = true;
+
+	rc = block_get_bsize(svcid, &block_size);
+	if (rc != EOK) {
+		bench_run_fail(run, "error determining device block size.");
+		goto error;
+	}
+
+	rc = block_get_nblocks(svcid, &dev_nblocks);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed to obtain block device size.\n");
+		goto error;
+	}
+
+	if (dev_nblocks < nb) {
+		bench_run_fail(run, "device is smaller than %u blocks.\n",
+		    nb);
+		goto error;
+	}
+
+	buf = malloc(block_size);
+	if (buf == NULL) {
+		bench_run_fail(run, "failed to allocate buffer (%zu bytes)",
+		    block_size);
+		goto error;
+	}
+
+	bench_run_start(run);
+	for (i = 0; i < size; i++) {
+		baddr = i % (dev_nblocks - nb + 1);
+
+		rc = block_read_direct(svcid, baddr, 1, buf);
+		if (rc != EOK) {
+			bench_run_fail(run, "failed to read blocks %llu-%llu: "
+			    "%s", (unsigned long long)baddr,
+			    (unsigned long long)(baddr + nb - 1),
+			    str_error(errno));
+			goto error;
+		}
+	}
+
+	bench_run_stop(run);
+	block_fini(svcid);
+	free(buf);
+
+	return true;
+error:
+	if (buf != NULL)
+		free(buf);
+	if (block_inited)
+		block_fini(svcid);
+	return false;
+}
+
+benchmark_t benchmark_seq_read = {
+	.name = "seq_read",
+	.desc = "Sequential disk read (must set 'disk' parameter).",
+	.entry = &runner,
+	.setup = NULL,
+	.teardown = NULL
+};
+
+/**
+ * @}
+ */
Index: uspace/app/hbench/env.c
===================================================================
--- uspace/app/hbench/env.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/hbench/env.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -81,5 +81,5 @@
 }
 
-static hash_table_ops_t param_hash_table_ops = {
+static const hash_table_ops_t param_hash_table_ops = {
 	.hash = param_hash,
 	.key_hash = param_key_hash,
@@ -97,5 +97,5 @@
 
 	env->run_count = DEFAULT_RUN_COUNT;
-	env->minimal_run_duration_nanos = MSEC2NSEC(DEFAULT_MIN_RUN_DURATION_SEC);
+	env->minimal_run_duration_nanos = MSEC2NSEC(DEFAULT_MIN_RUN_DURATION_MSEC);
 
 	return EOK;
Index: uspace/app/hbench/hbench.h
===================================================================
--- uspace/app/hbench/hbench.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/hbench/hbench.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2018 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2019 Vojtech Horky
  * All rights reserved.
@@ -43,5 +43,5 @@
 
 #define DEFAULT_RUN_COUNT 10
-#define DEFAULT_MIN_RUN_DURATION_SEC 10
+#define DEFAULT_MIN_RUN_DURATION_MSEC 1000
 
 /** Single run information.
@@ -135,8 +135,13 @@
 extern benchmark_t benchmark_fibril_mutex;
 extern benchmark_t benchmark_file_read;
+extern benchmark_t benchmark_rand_read;
+extern benchmark_t benchmark_seq_read;
 extern benchmark_t benchmark_malloc1;
 extern benchmark_t benchmark_malloc2;
 extern benchmark_t benchmark_ns_ping;
 extern benchmark_t benchmark_ping_pong;
+extern benchmark_t benchmark_read1k;
+extern benchmark_t benchmark_taskgetid;
+extern benchmark_t benchmark_write1k;
 
 #endif
